%close all;
lambda = -200; % constant in ODE: y'=lambda*y
step = 0.1; % integration step: h
TMAX = 1;  % interval of solution [0, TMAX]
figure;
fix = false; % auxilary variable for plotting
[t y] = eul(step, TMAX, lambda);
fix = fix || max(abs(y)) > 10;
plot(t,y, 'b');
hold on;
plot(t, exp(lambda * t), 'r');
[t y] = tay(step, TMAX, lambda, 2); % ORD = 2
fix = fix || max(abs(y)) > 10;
plot(t, y, 'g');
[t y] = tay(step, TMAX, lambda, 3); % ORD = 3
fix = fix || max(abs(y)) > 10;
plot(t, y, 'c');
[t y] = tay(step, TMAX, lambda, 4); % ORD = 4
fix = fix || max(abs(y)) > 10;
plot(t, y, 'm');
[t y] = tay(step, TMAX, lambda, 10); % ORD = 10
fix = fix || max(abs(y)) > 10;
plot(t, y, 'k');
legend('Euler', 'Exact solution', 'Taylor ORD = 2', 'Taylor ORD = 3', 'Taylor ORD = 4', 'Taylor ORD = 10');
xlabel('t');
ylabel('y');
title(sprintf('Explicit numerical methods (lambda = %i, z = %i)', lambda, step*lambda));
if fix
    axis([0 1 -10 10]);
end
hold off;