function [t y NewIterat2] = impl_tayNewtonSymb(step, tmax, lambda, ORD, TOL)
% [t y NewIterat2] = impl_tayNewton2(step, tmax, lambda, ORD, TOL)
% Newton method: y(j+1)=y(j)-f(y(j))/f'(y(j))
% symbolic computation of derivative f'(y(j))

t = (0:step:tmax);
y = zeros(length(t), 1);
NewIterat2 = zeros(length(t), 1);
y(1) = 1; % initial condition y(0) = 1
for i = 1:(length(t)-1)
    yj=inf; %inf
    yjj=y(i);
    NewIter=0;
    while (abs(yj-yjj)>TOL && NewIter<10) % Newton iteration
        yj=yjj;
        DY=yj;
        DYN=1; % y'(i+1,j)
        f=-yj+y(i);
        fN=-DYN; %+lambda*y(i);
        %fNN=-lambda*yj+step*lambda^2*yj-(step/2)*lambda^3*yj;
        for a = 1:ORD % recurrent calculation of Taylor series terms
            DY  = -(step/a)*lambda*DY;
            DYN = -(step/a)*lambda*DYN;
            f=f-DY;
            fN=fN-DYN;
        end
%        derf=(fN-f)/hN; % differential formula
        yjj=yj-f/fN; % Newton method
        NewIter=NewIter+1;
    end
    y(i+1)=yjj;
    NewIterat2(i+1)=NewIter;
end